package rocks.zipcode.io.quiz3.arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {

    String[][] board;

    public TicTacToe(String[][] board) {
        this.board = board;
    }

    public String[] getRow(Integer value) {
        return board[value];
    }

    public String[] getColumn(Integer value) {
        String[] column = new String[3];
        for(int i = 0; i<3; i++){
            column[i] = board[i][value];
        }
        return column;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        boolean boo = true;
        String[] row = getRow(rowIndex);
        for(int i = 0; i<2; i++){
            boo = row[i].equalsIgnoreCase(row[i+1]) && boo;

        }
        return boo;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        boolean boo = true;
        String[] column = getColumn(columnIndex);
        for(int i = 0; i<2; i++){
            boo = column[i].equalsIgnoreCase(column[i+1]) && boo;

        }
        return boo;
    }

    public String getWinner() {
        for(int i = 0; i<3; i++) {
            if (isColumnHomogeneous(i)){
                return getColumn(i)[0];
            } else if (isRowHomogenous(i)){
                return getRow(i)[0];
            } else if(board[0][0].equals(board[1][1]) && board[0][0].equals(board[2][2])){
                return board[0][0];
            } else if(board[1][1].equals(board[0][2]) && board[1][1].equals(board[2][0])){
                return board[1][1];
            }
        }
        return null;
    }
}
