package rocks.zipcode.io.quiz3.arrays;

import rocks.zipcode.io.quiz3.fundamentals.StringUtils;

import java.util.List;

/**
 * @author leon on 09/12/2018.
 */
public class WaveGenerator {

    public static String[] wave(String str) {
        String st = str.toLowerCase();
        int length = numOfChars(st);
        String[] wave = new String[length];
        for(int i = 0; i<length; i++){
            wave[i] = StringUtils.capitalizeNthCharacter(st, i);
        }
        return wave;

    }

    public static int numOfChars(String str){
        int count = 0;
        for(int i=0; i<str.length(); i++){
            if((str.charAt(i)>= 'A' && str.charAt(i)<='Z') || (str.charAt(i)>= 'a' && str.charAt(i)<='z')){
                count++;
            }
        }
        return count;
    }
}
