package rocks.zipcode.io.quiz3.generics;

import java.util.function.Function;

/**
 * @author leon on 09/12/2018.
 */
public class ArrayUtility<SomeType> {
    private final SomeType[] array;

    public ArrayUtility(SomeType[] array) {
        this.array = array;
    }

    public SomeType findOddOccurringValue() {
        for(Object o : array){
            if(getNumberOfOccurrences((SomeType)o)>1 && getNumberOfOccurrences((SomeType) o)%2 == 1){
                return (SomeType)o;
            }
        }
        return null;
    }

    public SomeType findEvenOccurringValue() {
        for(Object o : array){
            if(getNumberOfOccurrences((SomeType)o)>1 && getNumberOfOccurrences((SomeType) o)%2 == 0){
                return (SomeType)o;
            }
        }
        return null;
    }

    public Integer getNumberOfOccurrences(SomeType valueToEvaluate) {
        Integer count = 0;
        for(Object o: array){
            if(o.equals(valueToEvaluate)){
                count++;
            }
        }
        return count;
    }

    public SomeType[] filter(Function<SomeType, Boolean> predicate) {
        return null;
    }
}
